"""Change group key

Revision ID: 21bcf7db927c
Revises: 46698682c9a0
Create Date: 2016-03-16 14:46:09.617668

"""

# revision identifiers, used by Alembic.
revision = '21bcf7db927c'
down_revision = '46698682c9a0'

from alembic import op
import sqlalchemy as sa


def upgrade():
    ### commands auto generated by Alembic - please adjust! ###
    op.add_column('package_group_relation', sa.Column('package_name', sa.String()))
    op.execute("""
               UPDATE package_group_relation SET package_name =
                    (SELECT name FROM package WHERE package.id = package_group_relation.package_id)
               """)
    op.alter_column('package_group_relation', 'package_name', nullable=False)
    op.create_index('ix_package_group_relation_group_id', 'package_group_relation', ['group_id'], unique=False)
    op.create_index('ix_package_group_relation_package_name', 'package_group_relation', ['package_name'], unique=False)
    op.drop_constraint(u'package_group_relation_package_id_fkey', 'package_group_relation', type_='foreignkey')
    op.drop_column('package_group_relation', 'package_id')
    ### end Alembic commands ###


def downgrade():
    ### commands auto generated by Alembic - please adjust! ###
    op.add_column('package_group_relation', sa.Column('package_id', sa.INTEGER(), autoincrement=False, nullable=False))
    op.create_foreign_key(u'package_group_relation_package_id_fkey', 'package_group_relation', 'package', ['package_id'], ['id'], ondelete=u'CASCADE')
    op.drop_index('ix_package_group_relation_package_name', table_name='package_group_relation')
    op.drop_index('ix_package_group_relation_group_id', table_name='package_group_relation')
    op.drop_column('package_group_relation', 'package_name')
    ### end Alembic commands ###
